-- name: Nathaniel Bandy's Big House
-- description: \\#f8fe02\\--- \\#e74531\\N\\#00f251\\a\\#f8fe02\\t\\#2a7dff\\h\\#e74531\\a\\#f8fe02\\n\\#00f251\\i\\#e74531\\e\\#2a7dff\\l\\#f8fe02\\'\\#00f251\\s \\#00f251\\B\\#2a7dff\\i\\#e74531\\g \\#2a7dff\\H\\#e74531\\o\\#00f251\\u\\#f8fe02\\s\\#2a7dff\\e \\#f8fe02\\---\\#dcdcdc\\ \n\nThe 8th place entry into Simpleflips' 1st ROM hacking competition: Nathaniel Bandy.\n\nOrginal Author: \\#3b48cd\\Daniel_EDC\n\\#dcdcdc\\Ported by:\\#008800\\ Squishy6094 
-- incompatible: romhack

gLevelValues.entryLevel = LEVEL_CASTLE_GROUNDS
if gServerSettings.stayInLevelAfterStar == 0 then
    gServerSettings.stayInLevelAfterStar = 1
end

local function no_fall_damage(m)
    m.peakHeight = m.pos.y
end

local function no_act_select()
    return false
end

hook_event(HOOK_MARIO_UPDATE, no_fall_damage)
hook_event(HOOK_USE_ACT_SELECT, no_act_select)
gLevelValues.extendedPauseDisplay = true

camera_set_use_course_specific_settings(false)

E_MODEL_NB_COIN = smlua_model_util_get_id("NB_coin_geo")

function bhv_custom_secrets_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    obj_set_model_extended(o, E_MODEL_NB_COIN)
end

function bhv_custom_secrets_loop(o)
    local secret = obj_get_nearest_object_with_behavior_id(o, id_bhvHiddenStarTrigger)
    o.oFaceAngleYaw = o.oFaceAngleYaw + 0x800
    if secret == nil or secret.oPosX ~= o.oPosX or secret.oPosY ~= o.oPosY or secret.oPosZ ~= o.oPosZ then
        obj_mark_for_deletion(o)
    end
end

id_bhvCustomSecrets = hook_behavior(bhvCustomSecrets, OBJ_LIST_LEVEL, false, bhv_custom_secrets_init, bhv_custom_secrets_loop)

vec3f_set(gLevelValues.starPositions.KoopaBobStarPos, 3030, 4500, -4600)
vec3f_set(gLevelValues.starPositions.KoopaThiStarPos, 7100, -1300, -6000)
vec3f_set(gLevelValues.starPositions.KingBobombStarPos, 2000.0, 4500.0, -4500.0)
vec3f_set(gLevelValues.starPositions.KingWhompStarPos, 180.0, 3880.0, 340.0)
vec3f_set(gLevelValues.starPositions.EyerockStarPos, 0.0, -900.0, -3700.0)
vec3f_set(gLevelValues.starPositions.BigBullyStarPos, 0.0, 950.0, -6800.0)
vec3f_set(gLevelValues.starPositions.ChillBullyStarPos, 130.0, 1600.0, -4335.0)
vec3f_set(gLevelValues.starPositions.BigPiranhasStarPos, -6300.0, -1850.0, -6300.0)
vec3f_set(gLevelValues.starPositions.TuxieMotherStarPos, 3167.0, -4300.0, 5108.0)
vec3f_set(gLevelValues.starPositions.WigglerStarPos, 0.0, 2048.0, 0.0)
vec3f_set(gLevelValues.starPositions.PssSlideStarPos, -6358.0, -4300.0, 4700.0)
vec3f_set(gLevelValues.starPositions.RacingPenguinStarPos, -7339.0, -5700.0, -6774.0)
vec3f_set(gLevelValues.starPositions.TreasureChestStarPos, -1800.0, -2500.0, -1700.0)
vec3f_set(gLevelValues.starPositions.GhostHuntBooStarPos, 980.0, 1100.0, 250.0)
vec3f_set(gLevelValues.starPositions.KleptoStarPos, -5550.0, 300.0, -930.0)
vec3f_set(gLevelValues.starPositions.MerryGoRoundStarPos, -1600.0, -2100.0, 205.0)
vec3f_set(gLevelValues.starPositions.MrIStarPos, 1370.0, 2000.0, -320.0)
vec3f_set(gLevelValues.starPositions.BalconyBooStarPos, 700.0, 3200.0, 1900.0)
vec3f_set(gLevelValues.starPositions.BigBullyTrioStarPos, 3700.0, 600.0, -5500.0)